/******************************************************************************
													Copyright (c) Freescale 2009
File Name		 :	$RCSfile: main.c,v $
	
Engineer		 :	$Author: b21465 $

Location		 :	Brazil

Date Created	 :	15/09/2009

Current Revision :	$Revision: 1.0 $

Notes	:					

*******************************************************************************
Freescale reserves the right to make changes without further notice to any
product	herein to improve reliability, function	or design. Freescale does not
assume any liability arising out of the	application or use of any product,
circuit, or software described	herein;	neither	does it	convey any license
under its patent rights	nor the rights of others. Freescale products are	not
designed, intended, or authorized for use as components in systems intended for
surgical implant into the body, or other applications intended to support life,
or for any other application in which the failure of the  Freescale product
could create a	situation where	personal injury	or death may occur. Should
Buyer purchase or use Freescale products for any such unintended or
unauthorized application, Buyer shall idemnify and hold Freescale and its
officers, employees, subsidiaries, affiliates, and distributors	harmless
against	all claims costs, damages, and expenses, and reasonable	attorney fees 
arising	out of,	directly or indirectly,	any claim of personal injury or	death
associated with	such unintended	or unauthorized use, even if such claim alleges
that Freescale was negligent regarding the design or manufacture	of the part.
Freescale and the Freescale logo*	are registered trademarks of Freescale Ltd.
******************************************************************************/


#include "EE_AN_emulation.h"
#include "ee_emulation.h"

/************************* EEPROM Variables **********************************/

#pragma DATA_SEG EEPROM_VARS

UINT8  EepromVar1;		/* single byte */
UINT16 EepromVar2;		/* two bytes */
UINT8  EepromVar3[3];	/* three bytes */
UINT32 EepromVar4;		/* four bytes */
UINT32 teste;

#pragma DATA_SEG DEFAULT

/******************************************************************************
Function Name: main
Engineer:	     b21465
Date:          15/09/2009

Arguments:     none

Return:        none	 

Notes:         called from startup
******************************************************************************/

void
main(void)
{
	UINT8 writeData[4] = {0x01, 0x23, 0x45, 0x67};	
	VUINT8 readData[4];	
		
  InitEeprom();

  /* single byte */
	(void)WriteEeprom(&EepromVar1, writeData, sizeof(EepromVar1));

 /* 2 bytes, unaligned */
	(void)WriteEeprom(&EepromVar2, writeData, sizeof(EepromVar2));

	ReadEeprom(&EepromVar2, readData, sizeof(EepromVar2));

  /* 3 bytes unaligned */
	(void)WriteEeprom(EepromVar3, writeData, 3);

	/* 4 bytes aligned */
	(void)WriteEeprom(&EepromVar4, writeData, sizeof(EepromVar4));
	
	ReadEeprom(&EepromVar4, readData, sizeof(EepromVar4));
			
	for(;;);
}